<template>
  <div v-if="filteredGameEntrySelected.length > 0" class="mb-10 flex items-center flex-col lg:px-0 px-[10px] overflow-hidden">
    <div v-for="(game, index) in sortedSports" :key="index">
      <div v-if="isMobile" class="mobile-animation-container">
        <div class="flex flex-col">
          <div
            v-if="
              handleRemoveSpaceSpecialCharFormatted(game.GameName).includes(
                'sabasport'
              )
            "
            class="flex justify-center hsport_wrapper saba_bg"
          >
            <div class="px-3">
              <div class="pr-7">
                <div class="dm_heading_wrapper">
                  <div>{{ game.GameName }}</div>
                  <div class="bars">
                    <div v-for="item in 10" :key="item" class="bar"></div>
                  </div>
                </div>
                <div
                  v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                  class="text-sm leading-relaxed text-justify content-text-color"
                >
                  {{ $t(game.IntroForDisplay.long) }}
                </div>
                <div class="flex justify-center">
                  <div
                    class="text-sm btn --primary"
                    @click="
                      authenticated
                        ? handleGameSelected(game)
                        : toggleLoginRegisterDialog()
                    "
                  >
                    {{ $t("play_now") }}
                  </div>
                </div>
              </div>
              <div class="">
                <div class="stage img-parent">
                  <img
                    class="back-img bounce-1"
                    :src="
                      findThemeProperty(game.GameProviderShortName + '_1')
                        ?.ImagePath
                    "
                  />
                  <img
                    class="ibc-img-front bounce-2"
                    :src="
                      findThemeProperty(game.GameProviderShortName)?.ImagePath
                    "
                  />
                </div>
              </div>
            </div>
          </div>
          <div v-else class="">
            <div class="">
              <div class="dm_heading_wrapper">
                <div>{{ game.GameName }}</div>
                <div class="bars">
                  <div v-for="item in 10" :key="item" class="bar"></div>
                </div>
              </div>
              <div
                v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                class="text-sm content-text-color"
              >
                {{ $t(game.IntroForDisplay.long) }}
              </div>
              <div class="flex justify-center">
                <div
                  class="text-sm btn --primary"
                  @click="
                    authenticated
                      ? handleGameSelected(game)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("play_now") }}
                </div>
              </div>
            </div>
            <div class="stage img-parent h-[200px]">
              <img
                class="back-img bounce-1 w-[91%]"
                :src="
                  findThemeProperty(game.GameProviderShortName + '_1')
                    ?.ImagePath
                "
              />
              <img
                class="sbo-img-front bounce-2 w-[91%] right-[38px] top-0"
                :src="findThemeProperty(game.GameProviderShortName)?.ImagePath"
              />
            </div>
          </div>
        </div>
      </div>
      <div v-else class="desktop-animation-container">
        <div 
          class="flex flex-col items-center lg:mt-16 mt-96 pt-9"
          :class="{'hsport_wrapper saba_bg': handleRemoveSpaceSpecialCharFormatted(game.GameName).includes('sabasport')}"
        >
          <div class="container grid lg:grid-cols-2 grid-cols-1 relative items-center lg:!w-[1200px] !w-[100%]">
            <div :class="['stage img-parent flex justify-center !w-[100%] lg:!h-[360px] !h-auto', { 'order-2': index % 2 == 1 }]">
              <img
                class="back-img bounce-1 !w-[100%] !h-auto"
                :src="
                  findThemeProperty(game.GameProviderShortName + '_1')
                    ?.ImagePath
                "
              />
              <img
                class="sbo-img-front bounce-2 self-center lg:left-[30px] !inset-x-auto z-10"
                :src="findThemeProperty(game.GameProviderShortName)?.ImagePath"
              />
            </div>
            <div
              :class="[
                'flex flex-col leading-relaxed lg:relative absolute lg:top-0 top-[-350px] !w-full',
                index % 2 == 1 ? 'order-1 lg:pr-16' : 'lg:pl-32',
              ]"
            >
              <div class="dm_heading_wrapper md:mx-0 mr-5 flex flex-wrap lg:!pb-[25px] lg:!mb-[24px] !pb-0 !mb-0">
                <div class="lg:order-1 order-2">{{ game.GameName }}</div>
                <div class="bars lg:static relative inline-block lg:top-[70px] !top-[-15px] lg:mr-0 mr-[10px] lg:order-2 order-1">
                  <div v-for="item in 10" :key="item" class="bar"></div>
                </div>
              </div>
              <div
                v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                class="text-sm content-text-color sm:block !w-[100%]"
              >
                {{ $t(game.IntroForDisplay.long) }}
              </div>
              <div
                class="text-sm btn --primary md:mx-0 mr-5"
                @click="handleGameSelected(game)"
              >
                {{ $t("play_now") }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <common-login-dialog v-if="!isMobile" v-model="dialog" />
  </div>
  <div v-else>
    <lobby-no-game-message />
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { useGameEntryBaseOnTabSelected } from "@/composables/useTheme";
import { store } from "@/store";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { IGame } from "~~/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "GameListAnimation",
  props: {
    isSport: {
      type: Boolean,
      default: true,
    },
  },
  setup() {
    const router = useRouter();
    const { gameEntrySelected } = useGameEntryBaseOnTabSelected();
    const isMobile = !useIsDesktop();
    const dialog = ref(false);
    const providersFromThemeProperty =
      store.state.companyThemePropertiesFromApi.ThemeProperties.filter(
        (property) => property.HtmlId.startsWith("provider_")
      );
    const name = [
      "provider_afb",
      "provider_bti",
      "provider_digitain",
      "provider_saba",
      "provider_sbobet",
    ];
    const notHiddenProvider = providersFromThemeProperty
      .filter(
        (provider) => name.includes(provider.HtmlId) && !provider.IsHidden
      )
      .map((theme) => theme.HtmlId.substring(9));
    const gameFiltered = (game: string): boolean => {
      let cloneGame = game;
      if (game === "Saba Sports") cloneGame = "Saba";
      return notHiddenProvider.some((value) =>
        cloneGame.toLowerCase().includes(value)
      );
    };
    const orderByGameIDDesktop = [61, 1 , 59];
    const orderByGameIDMobile = [61, 1 , 64, 65, 59];
    const filteredGameEntrySelected = computed(() =>
      _.filter(
        gameEntrySelected.value,
        (sport) => sport !== undefined && gameFiltered(sport.GameProviderName)
      )
    );
    const sortedSports = _.sortBy(filteredGameEntrySelected.value, (game) => {
      const index = isMobile ? orderByGameIDMobile.indexOf(game.GameId) : orderByGameIDDesktop.indexOf(game.GameId);
      return index === -1 ? Infinity : index;
    });
    const {
      getAssetImage,
      handleRemoveSpaceSpecialCharFormatted,
      toggleLoginRegisterDialog,
    } = commonHelper;
    const authenticated = computed(() => store.state.auth);
    const findThemeProperty = (htmlId: string) => {
      let htmlId2 = htmlId;
      if (htmlId.toLowerCase().includes("sbo"))
        htmlId2 = htmlId.replace("SBO", "sbobet");
      if (htmlId.toLowerCase().includes("saba sports"))
        htmlId2 = htmlId.replace("Saba Sports", "saba");
      if (htmlId.toLowerCase().includes("afb sports"))
        htmlId2 = htmlId.replace("AFB Sports", "afb");
      if (htmlId.toLowerCase().includes("bti sports"))
        htmlId2 = htmlId.replace("BTi Sports", "bti");
      if (htmlId.toLowerCase().includes("digi"))
        htmlId2 = htmlId.replace("DIGI", "digitain");
      const pro = providersFromThemeProperty.find(
        (theme) => "provider_" + htmlId2.toLowerCase() === theme.HtmlId
      );
      return pro;
    };
    const sabaBgUrl = isMobile
      ? "assets/theme/common/images/mobilesabasportsbgcontainer.jpg"
      : "assets/theme/common/images/sabasportsbgcontainer.jpg";
    const sabaBg = `url(${getAssetImage(sabaBgUrl)})`;
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        if (item?.TabType !== undefined) {
          result = item?.TabType.replaceAll(" ", "-").toLowerCase();
        }
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const handleGameSelected = (game: IGame) => {
      if (authenticated.value) {
        if (!isMobile) {
          if (game.GameId === 74)
            handleGameEntryOpenWindow(
              game,
              1200,
              850,
              EnumEntranceLocation.GameLobby
            );
          else router.push(`/Game/${game.GameId}${tabTypeForRoute.value}`);
        } else {
          handleGameEntryOpenWindow(game, 850, 850);
        }
      } else if (!isMobile) router.push("/login");
      else dialog.value = true;
    };
    const checkIncludeUnderScore = (text: string) => {
      if (text.includes("_")) return true;
      return false;
    };
    return {
      filteredGameEntrySelected,
      isMobile,
      dialog,
      providersFromThemeProperty,
      notHiddenProvider,
      getAssetImage,
      authenticated,
      findThemeProperty,
      EnumEntranceLocation,
      sabaBg,
      handleRemoveSpaceSpecialCharFormatted,
      handleGameSelected,
      checkIncludeUnderScore,
      toggleLoginRegisterDialog,
      sortedSports,
    };
  },
});
</script>
<style scoped>
.dm_heading_wrapper {
  color: var(--primary);
  font-size: 32px;
  font-weight: 500;
  padding-bottom: 25px;
  margin-bottom: 30px;
  position: relative;
  text-transform: uppercase;
}
.btn {
  @apply inline-block text-center rounded-2xl text-white duration-300;
  min-width: 160px;
  margin-right: 1rem;
  width: 160px;
  margin-top: 26px;
  padding: 8px 20px;
}
.stage {
  display: flex;
  height: 430px;
  width: 110%;
}
.back-img {
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  height: 406px;
  transform-origin: bottom;
  width: 660px;
  position: relative;
  top: 0;
  right: 0;
}
.bounce-1 {
  animation-name: bounce-1;
  animation-timing-function: linear;
}
@keyframes bounce-1 {
  0% {
    transform: translateY(0);
  }
  50% {
    transform: translateY(-10px);
  }
  100% {
    transform: translateY(0);
  }
}
.bounce-2 {
  animation-name: bounce-2;
  animation-timing-function: linear;
}
@keyframes bounce-2 {
  0% {
    transform: translateY(0);
  }
  50% {
    transform: translateY(9px);
  }
  100% {
    transform: translateY(0);
  }
}
.bars {
  left: 2px;
  top: 70px;
  width: 40px;
}

.bar {
  background: var(--primary);
  bottom: 1px;
  height: 3px;
  position: absolute;
  width: 3px;
  animation: sound 0ms -800ms linear infinite alternate;
}

@keyframes sound {
  0% {
    opacity: 0.35;
    height: 3px;
  }
  100% {
    opacity: 1;
    height: 28px;
  }
}

.bar:nth-child(1) {
  left: 1px;
  animation-duration: 474ms;
}
.bar:nth-child(2) {
  left: 5px;
  animation-duration: 433ms;
}
.bar:nth-child(3) {
  left: 9px;
  animation-duration: 407ms;
}
.bar:nth-child(4) {
  left: 13px;
  animation-duration: 458ms;
}
.bar:nth-child(5) {
  left: 17px;
  animation-duration: 400ms;
}
.bar:nth-child(6) {
  left: 21px;
  animation-duration: 427ms;
}
.bar:nth-child(7) {
  left: 25px;
  animation-duration: 441ms;
}
.bar:nth-child(8) {
  left: 29px;
  animation-duration: 419ms;
}
.bar:nth-child(9) {
  left: 33px;
  animation-duration: 487ms;
}
.bar:nth-child(10) {
  left: 37px;
  animation-duration: 442ms;
}

.hsport_wrapper {
  background: #111;
  background-position: center 0;
  background-size: cover;
  padding-top: 88px;
  padding-bottom: 88px;
  width: 100%;
  width: 100vw;
  position: relative;
  left: 50%;
  right: 50%;
  margin-left: -50vw;
  margin-right: -50vw;
}
.desktop-animation-container .saba_bg {
  background: v-bind("sabaBg");
}
.sbo-img-front {
  position: absolute;
  top: -70px;
  left: 30px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
}
.ibc-img-front {
  position: absolute;
  top: -60px;
  left: 30px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
}
.cock-back-img {
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  height: 461px;
  transform-origin: bottom;
  width: 553px;
  position: relative;
  top: 0;
  right: 0;
}
.cock-img-front-1 {
  position: absolute;
  top: -30px;
  left: 392px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  height: 510px;
  width: 260px;
}
.cock-img-front-2 {
  position: absolute;
  top: -70px;
  left: -95px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  height: 510px;
  width: 260px;
}
.img-parent {
  position: relative;
  top: 0;
  left: 0;
}
</style>
<style lang="scss" scoped>
.mobile-animation-container {
  .img-parent {
    height: 200px;
    margin-top: 127px;
    .back-img {
      width: 91%;
      height: auto;
    }
    .sbo-img-front {
      width: 84%;
      left: 28px;
      top: -115px;
    }
    .ibc-img-front {
      width: 83%;
      left: 33px;
      top: -120px;
    }
    .cock-back-img {
      width: 91%;
      height: auto;
    }
    .cock-img-front-1 {
      width: 38%;
      height: auto;
      left: 213px;
      top: -147px;
    }
    .cock-img-front-2 {
      width: 38%;
      height: auto;
      left: 0;
      top: -147px;
    }
  }
  .hsport_wrapper {
    padding-top: 10px;
    padding-bottom: 20px;
  }
  .saba_bg {
    background-image: v-bind("sabaBg");
  }
}

.content-text-color {
  color: var(--text);
}
.game-content-white .content-text-color {
  color: var(--text2);
}
</style>
